<template>
  <div>
    <slot name="topPanel">
      <!-- Slot for placing additional pannels -->
    </slot>
    <table style="width:100%" class="tait-form">
      <!--
        If not editing the form component, display all fields given that their dependent fields (if any) have been met.
        Else display only the editable fields and the "always display" fields given that their dependent fields (if any) have been met.
      -->
      <tr v-for="field in fields" v-bind:key="field">
        <td class="edit-text" v-if="(!edit ? true: (field.editable || field.alwaysDisplay)) && checkDependentFields(field)">
          <label :for="field.field" class="p-col-fixed" style="width:100px">{{field.header}}</label></td>
        <td class="edit-boxes" v-if="(!edit ? true: (field.editable || field.alwaysDisplay)) && checkDependentFields(field)">
          <div class="p-col">
            <primevue-inputtext v-model="data[field.field]" v-if='field.type === "text"' :id="field.field" type="text"
                                :disabled="!edit || !field.editable" @input="textHandler(field)"></primevue-inputtext>

            <primevue-inputtext v-model="data[field.field]" v-if='field.type === "secondsAsInt"' :id="field.field" :disabled="!edit || !field.editable"/>

            <primevue-inputnumber v-model="data[field.field]" v-if='field.type === "number"' :id="field.field"
                                  :useGrouping="false" :disabled="!edit || !field.editable"></primevue-inputnumber>

            <primevue-dropdown v-model="data[field.field]" v-if='field.type === "dropdown"' :id="field.field"
                               :options="field.options" placeholder="None" class="p-column-filter" optionLabel="name"
                               optionValue="value" :disabled="!edit || !field.editable"></primevue-dropdown>

            <primevue-checkbox v-model="data[field.field]" v-if='field.type === "binary"' :id="field.field"
                               :binary="true" :disabled="!edit || !field.editable"></primevue-checkbox>

            <primevue-calendar v-model="data[field.field]" v-if='field.type === "date"' :id="field.field" :showButtonBar="true"
                               :showIcon="true" :showSeconds="true" dateFormat="yy-mm-dd" placeholder="yyyy-mm-dd" :showTime="true"
                               :disabled="!edit || !field.editable"></primevue-calendar>

            <!-- Linked Hex & Decimal field start -->
            <primevue-inputtext v-model="decimalData[field.field]" v-if='field.type === "hex"' placeholder="Decimal" @input="decimalHandler(field)"
                                :id="field.field+'Dec'" :disabled="!edit || !field.editable"></primevue-inputtext>

            <primevue-inputtext v-model="data[field.field]" v-if='field.type === "hex"' placeholder="Hexadecimal"
                                :maxlength="field?.size" @input="hexHandler(field)" :id="field.field" type="text"
                                :disabled="!edit || !field.editable"></primevue-inputtext>

            <!-- Linked Hex & Decimal field end -->
            <primevue-inputtext v-model="data[field.field]" v-if='field.type === "combo"'
                                placeholder="Hexadecimal" :id="field.field" type="text" :disabled="true" ></primevue-inputtext>
            
            <!-- lookup by sgid to find and set agency name -->
            <primevue-inputtext v-model="decimalData[field.field]" v-if='field.type === "sgidLookup"' placeholder="Decimal" 
                                :id="field.field+'Dec'" :disabled="!edit || !field.editable"
                                @input="decimalHandler(field)" />

            <primevue-inputtext v-model="data[field.field]" v-if='field.type === "sgidLookup"' placeholder="Hexadecimal"
                                :maxlength="field?.size" :id="field.field" type="text"
                                :disabled="!edit || !field.editable"
                                @input="hexHandler(field)" />

            <!-- ip pool field start -->
            <primevue-dropdown v-model="data[field.field]" v-if='field.type === "ipPools"' :id="field.field"
                               :options="field.ipPools" :placeholder="`Select ${field.header}`" class="p-column-filter" optionLabel="poolId"
                               optionValue="poolId" @change="resetStaticIp(field)" :disabled="!edit || !field.editable" />
            <!-- bind the static ip address to the secondary field -->
            <primevue-inputtext v-model="data[field.secondaryField]" v-if='field.type === "ipPools" && isStaticIpPool(field)' :id="field.secondaryField"
                                type="text" :disabled="!edit || !field.editable" @input="ipPoolsHandler(field)" placeholder="0.0.0.0"/>
            <!-- ip pool field end -->
          </div>
        </td>
      </tr>
    </table>
    <span class="form-buttons" v-if="create">
      <primevue-button class="p-button-raised" label="Save" icon="pi pi-save" :loading="loading" @click="submitCreate()"/>
      <primevue-button class="p-button-raised" label="Cancel" @click="$router.back()"/>
    </span>
    <span class="form-buttons" v-else>
      <primevue-button v-if="!edit && userCanEdit" class="p-button-raised" label="Edit" @click="enableEdit" icon="pi pi-pencil"/>
      <primevue-button v-else-if="edit && userCanEdit" class="p-button-raised" label="Save" @click="submitSave" icon="pi pi-save" :disabled="saveIsDisabled" :loading="loading"/>
      <primevue-button class="p-button-raised" :label="!edit ? 'Back' : 'Cancel'" @click="!edit ? $router.back() : cancelEdit()"/>
      <slot name="extraButtons" :formBottonClass="'p-button-raised'">
        <!-- Slot for extra buttons or dialogs to allow parents to acces initial data-->
      </slot>
    </span>
  </div>
</template>

<style>
.tait-form {
  font-size: 12px;
  width: 100%;
  margin-top: 20px;
}

.edit-text {
  text-align: right;
}

.edit-boxes {
  text-align: left;
}

.form-buttons {
  position: fixed;
  height: 47px;
  bottom: 0;
  left: 230px;
  z-index: 1;
}

.form-buttons .p-button-raised {
  border: none;
  background-color: #636c77;
  color: #e7e8e9;
  margin: 2px;
}

.form-buttons .p-button-raised:hover {
  background-color: #4a4f55;
  color: #ffffff;
}
</style>

<script lang="ts">
import axios from "axios";

import { defineComponent, PropType } from "vue";
import type { FieldType } from "@/types";
import { BASE_URL } from "@/utils";

export default defineComponent({
  props: {
    fields: {
      type: Object as PropType<FieldType[]>,
      required: true
    },
    url: {
      type: String,
      required: true
    },
    create: {
      type: Boolean,
      required: true
    },
    fieldsForAfterGetProcess: {
      type: Array as PropType<string[]>,
      default: [] as string[]
    }
  },

  data() {
    return {
      edit: false,
      loading: false,
      decimalData: {} as Record<string, string>,
      data: {} as Record<string, string | number>,
      initialData: {} as Record<string, string | number>,
      initialDecimalData: {} as Record<string, string>
    };
  },

  created() {
    if (this.create) {
      this.edit = true;
      this.setDefaultFieldValues();
    } else {
      this.loadData();
    }
  },

  computed: {
    /**Save button is only enabled if the current data differs from the original data*/
    saveIsDisabled(): boolean {
      // Do not compare against fields that have unmet dependencies as the keys are deleted
      const keysToExclude = [] as string[];
      for (const f of this.fields) {
        if (!this.checkDependentFields(f)) {
          keysToExclude.push(f.field);
        }
      }

      // Replace booleans with numeric values, remove keys with unmet dependencies
      const replacer = (key: string, value: string | number | boolean) => {
        if (keysToExclude.includes(key)) return undefined;
        if (typeof value === "boolean") {
          return value ? 1 : 0;
        }
        return value;
      };

      return JSON.stringify(this.initialData, replacer) == JSON.stringify(this.data, replacer);
    },

    userCanEdit(): boolean {
      return true;
    }
  },

  methods: {
    loadData() {
      // Get data to fill out form
    },

    hexHandler(field: FieldType) {
      let hexValue = (this.data[field.field] as string).replace(/[^0-9a-fA-F]/g, '').toUpperCase();
      const decimalValue = parseInt(hexValue, 16);
      const maxLength = field.size || 0;

      if (decimalValue) {
        this.decimalData[field.field] = decimalValue.toString(10);
        this.data[field.field] = hexValue;
      } else {
        this.decimalData[field.field] = "";
        this.data[field.field] = "";
      }

      if (field.combo) {
        this.comboHandler(field.combo, hexValue, maxLength);
      }
    },

    decimalHandler(field: FieldType) {
      let decimalValue = parseInt(this.decimalData[field.field].replace(/[^0-9]/g, ''));
      let hexValue = (this.data[field.field] as string || "").replace(/[^0-9a-fA-F]/g, '').toUpperCase();
      const maxLength = field.size || 0;

      if (isNaN(decimalValue)) {
        this.data[field.field] = "";
        this.decimalData[field.field] = "";
      } else if (decimalValue > ((16 ** maxLength) - 1)) {
        // Set the decimal value to be the previously set hex value on overflow
        this.decimalData[field.field] = parseInt(hexValue, 16).toString(10);
      } else {
        hexValue = decimalValue.toString(16).replace(/[^0-9a-fA-F]/g, '').toUpperCase();
        this.data[field.field] = hexValue;
        this.decimalData[field.field] = decimalValue.toString(10);
      }

      if (field.combo) {
        this.comboHandler(field.combo, hexValue, maxLength);
      }
    },

    comboHandler(combo: { key: string, location: number; }, toAppend: string, maxLength: number) {
      if (toAppend.length < maxLength) {
        toAppend = ('0'.repeat(maxLength - toAppend.length)) + toAppend;
      }

      let comboData = this.data[combo.key] as string;
      if (!comboData) {
        // Initialize the combo box data to the required length
        for (const f of this.fields) {
          if (f.field === combo.key) {
            comboData = "0".repeat(f.size || 0);
            break;
          }
        }
      }
      this.data[combo.key] = this.replaceAt(combo.location, toAppend, comboData);
    },

    ipPoolsHandler(ipField: FieldType) {
      if (!ipField.secondaryField) return;
      // Remove non-numbers and double dots
      this.data[ipField.secondaryField] = (this.data[ipField.secondaryField] as string).replace(/[^0-9.]/g, '');
      this.data[ipField.secondaryField] = (this.data[ipField.secondaryField] as string).replace(/\.\.+/g, '.');
      let ipAddress: string[] = (this.data[ipField.secondaryField] as string).split(".", 4);
      ipAddress.forEach((byteString, idx) => {
        const byteValue = parseInt(byteString);
        if (byteValue > 255 || byteValue < 0) {
          // Handle overflow
          ipAddress[idx] = byteString.slice(0, -1);
        } else if (byteString.startsWith("0") && byteString.length > 1) {
          // Handle beginning zeros
          ipAddress[idx] = byteString.slice(1);
        }
      });
      this.data[ipField.secondaryField] = ipAddress.join(".");
    },

    processAfterGetHooks() {
      for (const f of this.fields) {
        if (this.fieldsForAfterGetProcess?.includes(f.field)) {
          this.executeAfterGetHook(f);
        }
      }
    },

    executeAfterGetHook(field: FieldType) {
      if (field.combo) {
        let comboData = this.data[field.combo.key] as string;
        const value = comboData.substr(field.combo.location, field.size);
        this.data[field.field] = value;
        this.decimalData[field.field] = parseInt(value, 16).toString();
      }
    },

    textHandler(field: FieldType) {
      if (!field.size) return;
      let currValue = this.data[field.field] as string;
      if (currValue.length > field.size) {
        this.data[field.field] = currValue.slice(0, field.size);
      }
    },

    replaceAt(index: number, replacement: string, original: string) {
      return original.substr(0, index) + replacement + original.substr(index + replacement.length);
    },

    submitSave() {
      this.loading = true;
      this.$toast.removeAllGroups();
      // Save changes
      this.loading = false
    },

    submitCreate() {
      this.loading = true;
      this.$toast.removeAllGroups();
      // Create object
      this.loading = false
    },

    cancelEdit() {
      // Reset the data to the initial states
      this.data = { ...this.initialData };
      this.decimalData = { ...this.initialDecimalData };
      this.edit = false;
      this.processAfterGetHooks();
      this.$emit('editCancelled');
    },

    resetStaticIp(ipField: FieldType) {
      if (!ipField.secondaryField) return;
      // Delete the static ip when changing to a dynamic pool
      for (const pool of ipField.ipPools || []) {
        if (pool.poolId === this.data[ipField.field] && !pool.static) {
          delete this.data[ipField.secondaryField];
        }
      }
    },

    isStaticIpPool(ipField: FieldType) {
      // Check selected data to see if its a Static IP
      const poolId = this.data[ipField.field] as string;
      for (const pool of ipField.ipPools || []) {
        if (pool.poolId == poolId) return pool.static;
      }
      // This may not be safe but assume that it is dynamic
      return false;
    },

    checkDependentFields(field: FieldType): boolean {
      if (field.dependentFields === undefined) return true;

      if (field.dependentFields.matchAll) {
        // All conditions must be met
        for (const dep of field.dependentFields.dependsOn) {
          if (!dep.validValues.includes(this.data[dep.name])) {
            // Unmet dependency. clear existing data
            delete this.data[field.field];
            delete this.decimalData[field.field];
            return false;
          }
        }

        return true;
      } else {
        // One condition must be met
        for (const dep of field.dependentFields.dependsOn) {
          if (dep.validValues.includes(this.data[dep.name])) return true;
        }

        // Unmet dependency. clear existing data
        delete this.data[field.field];
        delete this.decimalData[field.field];
        return false;
      }

    },

    enableEdit() {
      this.$emit('editEnabled');
      this.edit = true;
    },

    async setDefaultFieldValues() {
      const idsToPopulate: FieldType[] = [];

      this.fields.forEach(f => {
        if (["systemId", "wacnId", "rfssId"].includes(f.field)) {
          idsToPopulate.push(f);
        } else if (f.defaultValue !== undefined) {
          this.data[f.field] = f.defaultValue;

          if (f.type === "hex" || f.type === "sgidLookup") {
            // Need to handle both cases
            if (typeof f.defaultValue === "string") {
              this.hexHandler(f);
            } else {
              this.decimalData[f.field] = f.defaultValue.toString();
              this.data[f.field] = f.defaultValue.toString(16).toUpperCase();
              this.decimalHandler(f);
            }
          }
        }
      });

      if (idsToPopulate.length > 0) {
        // Retrieve the default id for the Home RFSS
        try {
          const response = await axios.get(BASE_URL + "/info/homeids");

          for (const f of idsToPopulate) {
            // Handle for hex fields and non hex fields
            if (f.type === "hex") {
              this.decimalData[f.field] = response.data.rows[f.field].toString();
              this.data[f.field] = response.data.rows[f.field].toString(16).toUpperCase();
              this.decimalHandler(f);
            } else {
              this.data[f.field] = response.data.rows[f.field];
            }

          }

        } catch (err) {
          console.error(err);
        }
      }

    }
  }
});
</script>
